import { computed as p, ref as m, onMounted as ot, watch as Ee, openBlock as a, createElementBlock as o, normalizeClass as P, normalizeStyle as ce, createBlock as D, createCommentVNode as v, unref as c, createSlots as ut, withCtx as I, renderSlot as F, normalizeProps as q, guardReactiveProps as J, createVNode as st, createElementVNode as d, Fragment as k, renderList as _, toDisplayString as b, withKeys as nt, createTextVNode as Oe, nextTick as X } from "vue";
import { u as rt, o as it, e as Q, g as ct, c as Ve, t as vt, a as dt, p as Z, C as He, b as ht, J as yt, d as ve, D as Me, m as de, X as ft, s as G, E as gt, i as he, f as ee, j as We, k as te, n as Re, K as Ue, q as mt, r as bt } from "./index-BUHajhqq.js";
import { _ as xt } from "./Title-_dfoh5WC.js";
import { u as pt, U as kt } from "./usePrinter-DLHRtlhI.js";
import { D as _t } from "./DataTable-D7JlgAbC.js";
import { L as Ct } from "./Legend-CEhIHRJc.js";
import wt from "./vue-ui-skeleton-BXPvqUO_.js";
import { S as Lt } from "./Slicer-CRXNOGCh.js";
import zt from "./vue-ui-accordion-2QOotHrr.js";
import { u as Xe } from "./useNestedProp-a0uhe7rJ.js";
import { _ as At } from "./PackageVersion-8Ql1gdmo.js";
import { P as St } from "./PenAndPaper-b1ZmLra1.js";
import { _ as $t } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Nt = ["id"], It = ["xmlns", "viewBox"], Ft = ["id"], Pt = ["stop-color"], Tt = ["stop-color"], Dt = ["id"], Et = ["stop-color"], Ot = ["stop-color"], Vt = ["stop-color"], Ht = { key: 0 }, Mt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Wt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Rt = { key: 0 }, Ut = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Xt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Gt = ["x", "y", "font-size", "fill", "font-weight"], jt = ["text-anchor", "font-size", "fill", "transform"], Bt = ["x1", "y1", "x2", "y2", "stroke", "stroke-width"], Yt = { key: 1 }, Kt = ["cx", "cy", "r", "fill"], qt = { key: 0 }, Jt = { key: 0 }, Qt = ["d", "stroke"], Zt = ["text-anchor", "x", "y", "fill"], el = ["cx", "cy", "r", "fill"], tl = { key: 0 }, ll = ["cx", "cy", "fill"], al = { key: 1 }, ol = ["d", "fill", "stroke"], ul = { key: 2 }, sl = ["d", "fill", "stroke"], nl = ["x", "y", "font-size", "fill"], rl = ["x", "y", "width", "fill", "onClick"], il = ["x", "y", "width", "height", "onMouseenter", "onClick"], cl = {
  key: 3,
  "data-cy-zoom": "",
  class: "vue-ui-donut-evolution-dialog"
}, vl = ["x", "y", "width", "height", "fill"], dl = ["x1", "y1", "x2", "y2", "stroke"], hl = ["x1", "y2", "x2", "y1", "stroke"], yl = ["onKeypress", "cx", "cy", "r"], fl = ["d", "stroke"], gl = ["cx", "cy", "r", "fill"], ml = ["d", "fill", "stroke"], bl = { class: "vue-ui-donut-evolution-focus" }, xl = ["text-anchor", "x", "y", "fill"], pl = ["cx", "cy", "r", "fill"], kl = ["cx", "cy", "r", "fill"], _l = ["x", "y", "fill"], Cl = ["x", "y", "font-size", "fill"], wl = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ll = ["onClick"], zl = { key: 0 }, Al = { key: 1 }, Sl = {
  key: 9,
  ref: "source",
  dir: "auto"
}, $l = { key: 0 }, Nl = { key: 1 }, Il = {
  __name: "vue-ui-donut-evolution",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectLegend"],
  setup(Ge, { expose: je, emit: ye }) {
    const x = Ge, { vue_ui_donut_evolution: Be } = rt(), j = p(() => !!x.dataset && x.dataset.length), h = m({
      start: 0,
      end: Math.max(...x.dataset.map((l) => l.values.length))
    });
    function fe() {
      ge();
    }
    const V = m(null);
    async function ge() {
      (e.value.style.chart.zoom.startIndex !== null || e.value.style.chart.zoom.endIndex !== null) && V.value ? (e.value.style.chart.zoom.startIndex !== null && (await X(), await X(), V.value && V.value.setStartValue(e.value.style.chart.zoom.startIndex)), e.value.style.chart.zoom.endIndex !== null && (await X(), await X(), V.value && V.value.setEndValue(Ye(e.value.style.chart.zoom.endIndex + 1)))) : (h.value = {
        start: 0,
        end: O.value
      }, xe.value += 1);
    }
    function Ye(l) {
      const u = O.value;
      return l > u ? u : l < 0 || e.value.style.chart.zoom.startIndex !== null && l < e.value.style.chart.zoom.startIndex ? e.value.style.chart.zoom.startIndex !== null ? e.value.style.chart.zoom.startIndex + 1 : 1 : l;
    }
    ot(() => {
      me();
    });
    function me() {
      it(x.dataset) ? Q({
        componentName: "VueUiDonutEvolution",
        type: "dataset"
      }) : x.dataset.length && x.dataset.forEach((l, u) => {
        ct({
          datasetObject: l,
          requiredAttributes: ["name", "values"]
        }).forEach((t) => {
          Q({
            componentName: "VueUiDonutEvolution",
            type: "datasetSerieAttribute",
            property: t,
            index: u
          });
        });
      }), ge();
    }
    const E = m(Ve()), C = m([]), g = m(null), le = m(null), A = m(!1), S = m(null), ae = m(null), Ke = m(null), be = m(0), xe = m(0), pe = m(0), ke = m(0), _e = m(0), e = p({
      get: () => Ce(),
      set: (l) => l
    });
    function Ce() {
      const l = Xe({
        userConfig: x.config,
        defaultConfig: Be
      });
      let u = {};
      return l.theme ? u = {
        ...Xe({
          userConfig: vt.vue_ui_donut_evolution[l.theme] || x.config,
          defaultConfig: l
        }),
        customPalette: dt[l.theme] || Z
      } : u = l, x.config && He(x.config, "style.chart.zoom.startIndex") ? u.style.chart.zoom.startIndex = x.config.style.chart.zoom.startIndex : u.style.chart.zoom.startIndex = null, x.config && He(x.config, "style.chart.zoom.endIndex") ? u.style.chart.zoom.endIndex = x.config.style.chart.zoom.endIndex : u.style.chart.zoom.endIndex = null, u;
    }
    Ee(() => x.config, (l) => {
      e.value = Ce(), me(), pe.value += 1, ke.value += 1, _e.value += 1;
    }, { deep: !0 }), Ee(() => x.dataset, (l) => {
      fe();
    }, { deep: !0 });
    const { isPrinting: we, isImaging: Le, generatePdf: ze, generateImage: Ae } = pt({
      elementId: E.value,
      fileName: e.value.style.chart.title.text || "vue-ui-donut-evolution"
    }), qe = p(() => e.value.userOptions.show && !e.value.style.chart.title.text), Je = p(() => ht(e.value.customPalette)), B = m({
      showTable: e.value.table.show
    }), n = p(() => ({
      top: e.value.style.chart.layout.padding.top,
      right: e.value.style.chart.layout.padding.right,
      bottom: e.value.style.chart.layout.padding.bottom,
      left: e.value.style.chart.layout.padding.left
    })), i = p(() => {
      const l = e.value.style.chart.layout.height, u = e.value.style.chart.layout.width, t = l - n.value.top - n.value.bottom, r = u - n.value.left - n.value.right;
      return {
        absoluteHeight: l,
        absoluteWidth: u,
        centerX: n.value.left + r / 2,
        centerY: n.value.top + t / 2,
        height: t,
        width: r
      };
    }), T = p(() => (x.dataset.forEach((l, u) => {
      [null, void 0].includes(l.name) && Q({
        componentName: "VueUiDonutEvolution",
        type: "datasetSerieAttribute",
        property: "name",
        index: u
      }), [null, void 0].includes(l.values) && Q({
        componentName: "VueUiDonutEvolution",
        type: "datasetSerieAttribute",
        property: "values",
        index: u
      });
    }), x.dataset.map((l, u) => ({
      ...l,
      values: yt(l.values),
      color: ve(l.color) || Je.value[u] || Z[u] || Z[u % Z.length],
      length: (l.values || []).length,
      uid: Ve()
    })))), R = p(() => T.value.filter((l) => !C.value.includes(l.uid)).map((l) => ({
      ...l,
      values: l.values.filter((u, t) => t >= h.value.start && t <= h.value.end)
    }))), O = p(() => Math.max(...R.value.map((l) => l.length))), L = p(() => i.value.width / (h.value.end - h.value.start)), w = p(() => {
      const l = [];
      for (let s = 0; s < h.value.end - h.value.start; s += 1) {
        const f = R.value.map((N) => N.values[s] ?? null), y = f.filter((N) => [void 0, null].includes(N)).length === f.length, $ = f.reduce((N, z) => N + z, 0), ie = f.map((N) => N / $), W = n.value.left + L.value * s + L.value / 2;
        l.push({
          index: s,
          percentages: ie,
          subtotal: y || $ < 0 ? null : $,
          values: f,
          x: W
        });
      }
      const u = 0, t = Math.max(...l.map((s) => s.subtotal)), r = l.length === 1 ? t * 2 : t;
      return l.map((s, f) => {
        const y = L.value / 2 * 0.7, $ = y > i.value.width / 16 ? i.value.width / 16 : y, ie = g.value === s.index ? i.value.width / 16 : $, W = l.length > 4 ? y * 2 : y * 2 > L.value / 2 * 0.7 ? L.value / 2 * 0.7 : y * 2, N = i.value.absoluteHeight - n.value.bottom - i.value.height * s.subtotal / Me(u, r, e.value.style.chart.layout.grid.yAxis.dataLabels.steps).max;
        return {
          ...s,
          y: N,
          radius: $,
          activeRadius: ie,
          hoverRadius: W,
          donut: de({
            series: R.value.map((z, De) => ({
              color: z.color,
              name: z.name,
              value: z.values[f] ?? 0
            }))
          }, s.x, N, $, $, 1.99999, 2, 1, 360, 105.25, $ / 2),
          donutHover: de({
            series: R.value.map((z, De) => ({
              color: z.color,
              name: z.name,
              value: z.values[f] ?? 0
            }))
          }, s.x, N, W, W, 1.99999, 2, 1, 360, 105.25, W / 2),
          donutFocus: de({
            series: R.value.map((z, De) => ({
              color: z.color,
              name: z.name,
              value: z.values[f] ?? 0
            }))
          }, i.value.centerX, i.value.centerY, i.value.height / 3.6, i.value.height / 3.6, 1.99999, 2, 1, 360, 105.25, i.value.height / 6)
        };
      });
    });
    function Y(l, u, t) {
      return he(
        e.value.style.chart.layout.dataLabels.formatter,
        l,
        ee({
          p: e.value.style.chart.layout.dataLabels.prefix,
          v: l,
          s: e.value.style.chart.layout.dataLabels.suffix,
          r: e.value.style.chart.layout.dataLabels.rounding
        }),
        { datapoint: u, index: t }
      );
    }
    const oe = p(() => ({
      max: Math.max(...w.value.map((l) => l.subtotal)),
      min: 0
    })), H = p(() => {
      const l = w.value.length === 1 ? oe.value.max * 2 : oe.value.max;
      return Me(oe.value.min, l, e.value.style.chart.layout.grid.yAxis.dataLabels.steps);
    });
    function Qe(l) {
      return l / H.value.max;
    }
    const Ze = p(() => H.value.ticks.map((l) => ({
      y: i.value.absoluteHeight - n.value.bottom - i.value.height * Qe(l),
      value: l
    })));
    function Se(l, u) {
      return isNaN(l.value / Ue(u, "value")) ? 0 : (l.value / Ue(u, "value") * 100).toFixed(0) + "%";
    }
    function $e() {
      A.value || (g.value = null, le.value = null);
    }
    function et(l) {
      A.value || (g.value = l.index, le.value = l);
    }
    const ue = m(null);
    function se(l, u) {
      l.subtotal && (le.value = null, g.value = null, A.value = !0, S.value = l, [null, void 0].includes(u) || (ue.value = u));
    }
    function Ne() {
      S.value = null, A.value = !1, ue.value = null;
    }
    const Ie = p(() => T.value.map((l, u) => ({
      name: l.name,
      value: l.values.slice(h.value.start, h.value.end).reduce((t, r) => t + r, 0),
      shape: "circle",
      uid: l.uid,
      color: l.color
    })).sort((l, u) => u.value - l.value).map((l) => ({
      ...l,
      opacity: C.value.includes(l.uid) ? 0.5 : 1,
      segregate: () => ne(l.uid),
      isSegregated: C.value.includes(l.uid)
    }))), Fe = p(() => w.value.map((l) => l.subtotal).reduce((l, u) => l + u, 0)), tt = p(() => ({
      cy: "donut-div-legend",
      backgroundColor: e.value.style.chart.legend.backgroundColor,
      color: e.value.style.chart.legend.color,
      fontSize: e.value.style.chart.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.chart.legend.bold ? "bold" : ""
    }));
    function ne(l) {
      if (C.value.includes(l))
        C.value = C.value.filter((u) => u !== l), ye("selectLegend", null);
      else {
        if (C.value.length === T.value.length - 1) return;
        C.value.push(l), ye("selectLegend", T.value.find((u) => u.uid === l));
      }
      S.value && se(w.value.find((u, t) => t === ue.value));
    }
    const M = p(() => {
      const l = [""].concat(T.value.filter((s) => !C.value.includes(s.uid)).map((s) => ({
        name: s.name,
        color: s.color
      }))).concat(["Σ"]);
      let u = [];
      for (let s = 0; s < O.value; s += 1) {
        const f = T.value.filter((y) => !C.value.includes(y.uid)).map((y) => y.values[s] ?? 0).reduce((y, $) => y + $, 0);
        u.push([e.value.style.chart.layout.grid.xAxis.dataLabels.values[s] ?? "-"].concat(T.value.filter((y) => !C.value.includes(y.uid)).map((y) => ({
          value: y.values[s] ?? 0,
          percentage: y.values[s] ? y.values[s] / f * 100 : 0
        }))).concat([`${e.value.style.chart.layout.dataLabels.prefix}${Number(f.toFixed(e.value.table.td.roundingValue))}${e.value.style.chart.layout.dataLabels.suffix}`]));
      }
      const t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      }, r = [
        e.value.table.columnNames.period
      ].concat(T.value.filter((s) => !C.value.includes(s.uid)).map((s) => s.name)).concat(e.value.table.columnNames.total);
      return { head: l, body: u, config: t, colNames: r };
    });
    function lt() {
      return T.value;
    }
    function Pe() {
      X(() => {
        const l = [[e.value.style.chart.title.text], [e.value.style.chart.title.subtitle.text], [""]], u = [...M.value.head.map((f) => f.name ?? f)], t = [...M.value.body.map((f) => f.map((y) => y.value ?? y))], r = l.concat([u]).concat(t), s = mt(r);
        bt({ csvContent: s, title: e.value.style.chart.title.text || "vue-ui-donut-evolution" });
      });
    }
    const U = m(!1);
    function at(l) {
      U.value = l, be.value += 1;
    }
    function Te() {
      B.value.showTable = !B.value.showTable;
    }
    const K = m(!1);
    function re() {
      K.value = !K.value;
    }
    return je({
      getData: lt,
      generatePdf: ze,
      generateCsv: Pe,
      generateImage: Ae,
      toggleTable: Te,
      toggleAnnotator: re
    }), (l, u) => (a(), o("div", {
      ref_key: "donutEvolutionChart",
      ref: ae,
      class: P(`vue-ui-donut-evolution ${U.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      style: ce(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.chart.backgroundColor}`),
      id: E.value
    }, [
      e.value.userOptions.buttons.annotator ? (a(), D(St, {
        key: 0,
        parent: ae.value,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        active: K.value,
        onClose: re
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : v("", !0),
      qe.value ? (a(), o("div", {
        key: 1,
        ref_key: "noTitle",
        ref: Ke,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : v("", !0),
      e.value.style.chart.title.text ? (a(), o("div", {
        key: 2,
        style: "width:100%;background:transparent;padding-bottom:24px",
        onMouseleave: $e
      }, [
        (a(), D(xt, {
          key: `title_${pe.value}`,
          config: {
            title: {
              cy: "donut-evolution-div-title",
              ...e.value.style.chart.title
            },
            subtitle: {
              cy: "donut-evolution-div-subtitle",
              ...e.value.style.chart.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 32)) : v("", !0),
      e.value.userOptions.show && j.value ? (a(), D(kt, {
        ref: "details",
        key: `user_options_${be.value}`,
        backgroundColor: e.value.style.chart.backgroundColor,
        color: e.value.style.chart.color,
        isPrinting: c(we),
        isImaging: c(Le),
        uid: E.value,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: U.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: ae.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: K.value,
        onToggleFullscreen: at,
        onGeneratePdf: c(ze),
        onGenerateCsv: Pe,
        onGenerateImage: c(Ae),
        onToggleTable: Te,
        onToggleAnnotator: re
      }, ut({ _: 2 }, [
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: I(() => [
            F(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: I(() => [
            F(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: I(() => [
            F(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: I(() => [
            F(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: I(({ toggleFullscreen: t, isFullscreen: r }) => [
            F(l.$slots, "optionFullscreen", q(J({ toggleFullscreen: t, isFullscreen: r })), void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: I(({ toggleAnnotator: t, isAnnotator: r }) => [
            F(l.$slots, "optionAnnotator", q(J({ toggleAnnotator: t, isAnnotator: r })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage"])) : v("", !0),
      j.value ? (a(), o("svg", {
        key: 4,
        xmlns: c(ft),
        class: P({ "vue-data-ui-fullscreen--on": U.value, "vue-data-ui-fulscreen--off": !U.value }),
        viewBox: `0 0 ${i.value.absoluteWidth} ${i.value.absoluteHeight}`,
        style: ce(`max-width:100%; overflow: visible; background:transparent;color:${e.value.style.chart.color}`)
      }, [
        st(At),
        d("defs", null, [
          d("linearGradient", {
            id: `hover_${E.value}`,
            x1: "0%",
            y1: "0%",
            x2: "0%",
            y2: "100%"
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": c(G)(e.value.style.chart.backgroundColor, e.value.style.chart.layout.highlighter.opacity)
            }, null, 8, Pt),
            d("stop", {
              offset: "100%",
              "stop-color": c(G)(e.value.style.chart.layout.highlighter.color, e.value.style.chart.layout.highlighter.opacity)
            }, null, 8, Tt)
          ], 8, Ft),
          d("radialGradient", {
            id: `focus_${E.value}`
          }, [
            d("stop", {
              offset: "0%",
              "stop-color": c(G)(c(ve)(e.value.style.chart.backgroundColor), 0)
            }, null, 8, Et),
            d("stop", {
              offset: "77%",
              "stop-color": c(G)("#FFFFFF", 30)
            }, null, 8, Ot),
            d("stop", {
              offset: "100%",
              "stop-color": c(G)(c(ve)(e.value.style.chart.backgroundColor), 0)
            }, null, 8, Vt)
          ], 8, Dt)
        ]),
        e.value.style.chart.layout.grid.show ? (a(), o("g", Ht, [
          d("line", {
            x1: n.value.left,
            x2: n.value.left,
            y1: n.value.top,
            y2: n.value.top + i.value.height,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Mt),
          d("line", {
            x1: n.value.left,
            x2: i.value.absoluteWidth - n.value.right,
            y1: i.value.absoluteHeight - n.value.bottom,
            y2: i.value.absoluteHeight - n.value.bottom,
            stroke: e.value.style.chart.layout.grid.stroke,
            "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Wt),
          e.value.style.chart.layout.grid.showVerticalLines ? (a(), o("g", Rt, [
            (a(!0), o(k, null, _(h.value.end - h.value.start, (t, r) => (a(), o("line", {
              x1: n.value.left + (r + 1) * L.value,
              x2: n.value.left + (r + 1) * L.value,
              y1: n.value.top,
              y2: i.value.absoluteHeight - n.value.bottom,
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth,
              "stroke-linecap": "round"
            }, null, 8, Ut))), 256))
          ])) : v("", !0)
        ])) : v("", !0),
        e.value.style.chart.layout.grid.yAxis.dataLabels.show ? (a(), o("g", {
          key: 1,
          class: P({ "donut-opacity": !0, "donut-behind": g.value !== null || A.value })
        }, [
          (a(!0), o(k, null, _(Ze.value, (t, r) => (a(), o("g", null, [
            t.value >= H.value.min && t.value <= H.value.max ? (a(), o("line", {
              key: 0,
              x1: n.value.left,
              x2: n.value.left - 5,
              y1: t.y,
              y2: t.y,
              stroke: e.value.style.chart.layout.grid.stroke,
              "stroke-width": e.value.style.chart.layout.grid.strokeWidth
            }, null, 8, Xt)) : v("", !0),
            t.value >= H.value.min && t.value <= H.value.max ? (a(), o("text", {
              key: 1,
              x: n.value.left - 8 + e.value.style.chart.layout.grid.yAxis.dataLabels.offsetX,
              y: t.y + e.value.style.chart.layout.grid.yAxis.dataLabels.fontSize / 3,
              "font-size": e.value.style.chart.layout.grid.yAxis.dataLabels.fontSize,
              "text-anchor": "end",
              fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
              "font-weight": e.value.style.chart.layout.grid.yAxis.dataLabels.bold ? "bold" : "normal"
            }, b(c(gt)(t.value) ? c(he)(
              e.value.style.chart.layout.dataLabels.formatter,
              t.value,
              c(ee)({
                p: e.value.style.chart.layout.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabels.suffix,
                r: e.value.style.chart.layout.grid.yAxis.dataLabels.roundingValue
              }),
              { datapoint: t, seriesIndex: r }
            ) : ""), 9, Gt)) : v("", !0)
          ]))), 256))
        ], 2)) : v("", !0),
        e.value.style.chart.layout.grid.xAxis.dataLabels.show ? (a(), o("g", {
          key: 2,
          class: P({ "donut-opacity": !0, "donut-behind": A.value })
        }, [
          (a(!0), o(k, null, _(h.value.end - h.value.start, (t, r) => (a(), o("g", null, [
            e.value.style.chart.layout.grid.xAxis.dataLabels.showOnlyFirstAndLast && (r === 0 || r === O.value - 1) || !e.value.style.chart.layout.grid.xAxis.dataLabels.showOnlyFirstAndLast ? (a(), o("text", {
              key: 0,
              "text-anchor": e.value.style.chart.layout.grid.xAxis.dataLabels.rotation > 0 ? "start" : e.value.style.chart.layout.grid.xAxis.dataLabels.rotation < 0 ? "end" : "middle",
              "font-size": e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize,
              fill: e.value.style.chart.layout.grid.xAxis.dataLabels.color,
              transform: `translate(${n.value.left + L.value * r + L.value / 2}, ${e.value.style.chart.layout.grid.xAxis.dataLabels.offsetY + i.value.absoluteHeight - n.value.bottom + e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 2}), rotate(${e.value.style.chart.layout.grid.xAxis.dataLabels.rotation})`
            }, b(e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(r) + Number(h.value.start)] ?? ""), 9, jt)) : v("", !0)
          ]))), 256))
        ], 2)) : v("", !0),
        (a(!0), o(k, null, _(w.value, (t, r) => (a(), o("g", null, [
          e.value.style.chart.layout.line.show && r < w.value.length - 1 && ![t.subtotal, w.value[r + 1].subtotal].includes(null) ? (a(), o("line", {
            key: 0,
            class: P({ "donut-opacity": !0, "donut-behind": g.value !== null || A.value }),
            x1: t.x,
            y1: t.y,
            x2: w.value[r + 1].x,
            y2: w.value[r + 1].y,
            stroke: e.value.style.chart.layout.line.stroke,
            "stroke-width": e.value.style.chart.layout.line.strokeWidth,
            "stroke-linecap": "round",
            "stroke-linejoin": "round"
          }, null, 10, Bt)) : v("", !0),
          t.subtotal !== null ? (a(), o("g", Yt, [
            t.subtotal ? (a(), o("circle", {
              key: 0,
              cx: t.x,
              cy: t.y,
              r: t.activeRadius,
              fill: e.value.style.chart.backgroundColor
            }, null, 8, Kt)) : v("", !0)
          ])) : v("", !0)
        ]))), 256)),
        (a(!0), o(k, null, _(w.value, (t, r) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": r !== g.value && g.value !== null || A.value })
        }, [
          t.subtotal ? (a(), o("g", qt, [
            g.value !== null && g.value === r ? (a(), o("g", Jt, [
              (a(!0), o(k, null, _(t.donutHover, (s) => (a(), o("g", null, [
                d("path", {
                  d: c(We)(s, { x: s.center.endX, y: s.center.endY }, 12, 12, { x: t.x, y: t.y }, !0, 20),
                  stroke: s.color,
                  "stroke-width": "1",
                  "stroke-linecap": "round",
                  "stroke-linejoin": "round",
                  fill: "none"
                }, null, 8, Qt)
              ]))), 256)),
              (a(!0), o(k, null, _(t.donutHover, (s, f) => (a(), o("g", null, [
                d("text", {
                  "data-cy-hover-label": "",
                  "text-anchor": c(te)(s, !0, 0).anchor,
                  x: c(te)(s, !0, 3).x,
                  y: c(Re)(s),
                  fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
                  "font-size": 8,
                  "font-weight": "bold"
                }, b(s.name) + ": " + b(Se(s, t.donut)) + " (" + b(s.value === null ? "-" : Y(s.value, s, f)) + ") ", 9, Zt)
              ]))), 256)),
              d("g", null, [
                d("circle", {
                  cx: t.x,
                  cy: t.y,
                  r: t.hoverRadius,
                  fill: e.value.style.chart.backgroundColor
                }, null, 8, el)
              ])
            ])) : v("", !0)
          ])) : v("", !0)
        ], 2))), 256)),
        (a(!0), o(k, null, _(w.value, (t, r) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": r !== g.value && g.value !== null || A.value })
        }, [
          t.subtotal !== null ? (a(), o("g", tl, [
            t.subtotal === 0 ? (a(), o("circle", {
              key: 0,
              cx: t.x,
              cy: t.y,
              r: 3,
              fill: e.value.style.chart.color
            }, null, 8, ll)) : g.value !== null && g.value === r ? (a(), o("g", al, [
              (a(!0), o(k, null, _(t.donutHover, (s, f) => (a(), o("path", {
                d: s.arcSlice,
                fill: `${s.color}`,
                "stroke-width": 1,
                stroke: e.value.style.chart.backgroundColor
              }, null, 8, ol))), 256))
            ])) : (a(), o("g", ul, [
              (a(!0), o(k, null, _(t.donut, (s, f) => (a(), o("path", {
                d: s.arcSlice,
                fill: `${s.color}`,
                "stroke-width": 0.5,
                stroke: e.value.style.chart.backgroundColor
              }, null, 8, sl))), 256))
            ]))
          ])) : v("", !0)
        ], 2))), 256)),
        (a(!0), o(k, null, _(w.value, (t, r) => (a(), o("g", {
          class: P({ "donut-opacity": !0, "donut-behind": r !== g.value && g.value !== null || A.value })
        }, [
          t.subtotal !== null && e.value.style.chart.layout.dataLabels.show ? (a(), o("text", {
            key: 0,
            "text-anchor": "middle",
            x: t.x,
            y: g.value === t.index && t.subtotal ? t.y + e.value.style.chart.layout.dataLabels.fontSize / 3 : t.y - t.radius - e.value.style.chart.layout.dataLabels.fontSize + e.value.style.chart.layout.dataLabels.offsetY,
            "font-size": e.value.style.chart.layout.dataLabels.fontSize,
            "font-weight": "bold",
            fill: e.value.style.chart.layout.dataLabels.color
          }, b(Y(t.subtotal, t, r)), 9, nl)) : v("", !0)
        ], 2))), 256)),
        (a(!0), o(k, null, _(w.value, (t, r) => (a(), o("rect", {
          x: n.value.left + r * L.value,
          y: i.value.absoluteHeight - n.value.bottom - 10,
          width: L.value,
          height: 10,
          fill: g.value === t.index ? `url(#hover_${E.value})` : "transparent",
          onClick: (s) => se(t, r),
          class: P({ "donut-hover": g.value === t.index && t.subtotal })
        }, null, 10, rl))), 256)),
        (a(!0), o(k, null, _(w.value, (t, r) => (a(), o("rect", {
          "data-cy-trap": "",
          x: n.value.left + r * L.value,
          y: n.value.top,
          width: L.value,
          height: i.value.height,
          fill: "transparent",
          onMouseenter: (s) => et(t),
          onMouseleave: $e,
          onClick: (s) => se(t, r),
          class: P({ "donut-hover": g.value === t.index && t.subtotal })
        }, null, 42, il))), 256)),
        A.value ? (a(), o("g", cl, [
          d("rect", {
            rx: 4,
            x: n.value.left,
            y: n.value.top,
            width: i.value.width,
            height: i.value.height,
            fill: e.value.style.chart.backgroundColor,
            style: { filter: "drop-shadow(0 12px 12px rgba(0,0,0,0.3))" }
          }, null, 8, vl),
          d("line", {
            "data-html2canvas-ignore": "",
            x1: i.value.absoluteWidth - n.value.right - 15,
            y1: n.value.top + 5,
            x2: i.value.absoluteWidth - n.value.right - 4,
            y2: n.value.top + 15.5,
            "stroke-linecap": "round",
            stroke: e.value.style.chart.color,
            "stroke-width": "1.5"
          }, null, 8, dl),
          d("line", {
            "data-html2canvas-ignore": "",
            x1: i.value.absoluteWidth - n.value.right - 15,
            y2: n.value.top + 5,
            x2: i.value.absoluteWidth - n.value.right - 4,
            y1: n.value.top + 15.5,
            "stroke-linecap": "round",
            stroke: e.value.style.chart.color,
            "stroke-width": "1.5"
          }, null, 8, hl),
          d("circle", {
            "data-cy-close": "",
            onClick: Ne,
            onKeypress: nt(Ne, ["enter"]),
            cx: i.value.absoluteWidth - n.value.right - i.value.width / 40,
            cy: n.value.top + i.value.height / 30,
            r: i.value.height / 12,
            fill: "transparent",
            style: { cursor: "pointer" },
            tabindex: "0"
          }, null, 40, yl),
          (a(!0), o(k, null, _(S.value.donutFocus, (t) => (a(), o("g", null, [
            d("path", {
              "data-cy-zoom-donut": "",
              d: c(We)(t, { x: i.value.centerX, y: i.value.centerY }, 12, 12, !1, !1, 15),
              stroke: t.color,
              "stroke-width": "1",
              "stroke-linecap": "round",
              "stroke-linejoin": "round",
              fill: "none",
              class: "vue-ui-donut-evolution-focus"
            }, null, 8, fl)
          ]))), 256)),
          d("circle", {
            cx: n.value.left + i.value.width / 2,
            cy: n.value.top + i.value.height / 2,
            r: i.value.height / 7,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, gl),
          (a(!0), o(k, null, _(S.value.donutFocus, (t, r) => (a(), o("path", {
            d: t.arcSlice,
            fill: `${t.color}`,
            "stroke-width": 1,
            stroke: e.value.style.chart.backgroundColor,
            class: "vue-ui-donut-evolution-focus"
          }, null, 8, ml))), 256)),
          (a(!0), o(k, null, _(S.value.donutFocus, (t, r) => (a(), o("g", bl, [
            d("text", {
              "text-anchor": c(te)(t, !0, 20).anchor,
              x: c(te)(t, !0, 10).x,
              y: c(Re)(t),
              fill: e.value.style.chart.layout.grid.yAxis.dataLabels.color,
              "font-size": 10,
              "font-weight": "bold"
            }, b(t.name) + ": " + b(Se(t, S.value.donutFocus)) + " (" + b(t.value === null ? "-" : Y(t.value, t, r)) + ") ", 9, xl)
          ]))), 256)),
          d("circle", {
            cx: n.value.left + i.value.width / 2,
            cy: n.value.top + i.value.height / 2,
            r: i.value.height / 3.8,
            fill: `url(#focus_${E.value})`
          }, null, 8, pl),
          d("circle", {
            cx: n.value.left + i.value.width / 2,
            cy: n.value.top + i.value.height / 2,
            r: i.value.height / 7.7,
            fill: e.value.style.chart.backgroundColor
          }, null, 8, kl),
          d("text", {
            "text-anchor": "middle",
            x: n.value.left + i.value.width / 2,
            y: n.value.top + i.value.height / 2 + 14 / 3,
            "font-size": 14,
            "font-weight": "bold",
            fill: e.value.style.chart.layout.dataLabels.color,
            class: "vue-ui-donut-evolution-focus"
          }, b(Y(S.value.subtotal, S.value, null)), 9, _l),
          e.value.style.chart.layout.grid.xAxis.dataLabels.values[S.value.index] ? (a(), o("text", {
            key: 0,
            x: n.value.left + 6,
            y: n.value.top + e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 2,
            "font-size": e.value.style.chart.layout.grid.xAxis.dataLabels.fontSize * 1.6,
            fill: e.value.style.chart.layout.dataLabels.color
          }, b(e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(S.value.index) + Number(h.value.start)]), 9, Cl)) : v("", !0)
        ])) : v("", !0),
        F(l.$slots, "svg", { svg: i.value }, void 0, !0)
      ], 14, It)) : v("", !0),
      l.$slots.watermark ? (a(), o("div", wl, [
        F(l.$slots, "watermark", q(J({ isPrinting: c(we) || c(Le) })), void 0, !0)
      ])) : v("", !0),
      j.value ? v("", !0) : (a(), D(wt, {
        key: 6,
        config: {
          type: "donutEvolution",
          style: {
            backgroundColor: e.value.style.chart.backgroundColor,
            donutEvolution: {
              axis: {
                color: "#CCCCCC"
              },
              donuts: {
                color: "#CCCCCC"
              }
            }
          }
        }
      }, null, 8, ["config"])),
      O.value > 1 && e.value.style.chart.zoom.show ? (a(), D(Lt, {
        ref_key: "slicerComponent",
        ref: V,
        key: `slicer_${xe.value}`,
        background: e.value.style.chart.zoom.color,
        borderColor: e.value.style.chart.backgroundColor,
        fontSize: e.value.style.chart.zoom.fontSize,
        useResetSlot: e.value.style.chart.zoom.useResetSlot,
        labelLeft: e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(h.value.start)] || "",
        labelRight: e.value.style.chart.layout.grid.xAxis.dataLabels.values[Number(h.value.end) - 1] || "",
        textColor: e.value.style.chart.color,
        inputColor: e.value.style.chart.zoom.color,
        selectColor: e.value.style.chart.zoom.highlightColor,
        max: O.value,
        min: 0,
        valueStart: h.value.start,
        valueEnd: h.value.end,
        start: h.value.start,
        "onUpdate:start": u[0] || (u[0] = (t) => h.value.start = t),
        end: h.value.end,
        "onUpdate:end": u[1] || (u[1] = (t) => h.value.end = t),
        refreshStartPoint: e.value.style.chart.zoom.startIndex !== null ? e.value.style.chart.zoom.startIndex : 0,
        refreshEndPoint: e.value.style.chart.zoom.endIndex !== null ? e.value.style.chart.zoom.endIndex + 1 : O.value,
        onReset: fe
      }, {
        "reset-action": I(({ reset: t }) => [
          F(l.$slots, "reset-action", q(J({ reset: t })), void 0, !0)
        ]),
        _: 3
      }, 8, ["background", "borderColor", "fontSize", "useResetSlot", "labelLeft", "labelRight", "textColor", "inputColor", "selectColor", "max", "valueStart", "valueEnd", "start", "end", "refreshStartPoint", "refreshEndPoint"])) : v("", !0),
      e.value.style.chart.legend.show ? (a(), D(Ct, {
        key: `legend_${_e.value}`,
        legendSet: Ie.value,
        config: tt.value,
        onClickMarker: u[2] || (u[2] = ({ legend: t }) => ne(t.uid))
      }, {
        item: I(({ legend: t, index: r }) => [
          d("div", {
            "data-cy-legend-item": "",
            onClick: (s) => ne(t.uid),
            style: ce(`opacity:${C.value.includes(t.uid) ? 0.5 : 1}`)
          }, [
            Oe(b(t.name) + ": " + b(c(he)(
              e.value.style.chart.layout.dataLabels.formatter,
              t.value,
              c(ee)({
                p: e.value.style.chart.layout.dataLabels.prefix,
                v: t.value,
                s: e.value.style.chart.layout.dataLabels.suffix,
                r: e.value.style.chart.legend.roundingValue
              }),
              { datapoint: t, seriesIndex: r }
            )) + " ", 1),
            C.value.includes(t.uid) ? (a(), o("span", Al, " ( - % ) ")) : (a(), o("span", zl, " (" + b(isNaN(t.value / Fe.value) ? "-" : c(ee)({
              v: t.value / Fe.value * 100,
              s: "%",
              r: e.value.style.chart.legend.roundingPercentage
            })) + ") ", 1))
          ], 12, Ll)
        ]),
        _: 1
      }, 8, ["legendSet", "config"])) : v("", !0),
      F(l.$slots, "legend", { legend: Ie.value }, void 0, !0),
      l.$slots.source ? (a(), o("div", Sl, [
        F(l.$slots, "source", {}, void 0, !0)
      ], 512)) : v("", !0),
      j.value ? (a(), D(zt, {
        key: 10,
        hideDetails: "",
        config: {
          open: B.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          },
          head: {
            backgroundColor: e.value.style.chart.backgroundColor,
            color: e.value.style.chart.color
          }
        }
      }, {
        content: I(() => [
          (a(), D(_t, {
            key: `table_${ke.value}`,
            colNames: M.value.colNames,
            head: M.value.head,
            body: M.value.body,
            config: M.value.config,
            title: `${e.value.style.chart.title.text}${e.value.style.chart.title.subtitle.text ? ` : ${e.value.style.chart.title.subtitle.text}` : ""}`,
            onClose: u[3] || (u[3] = (t) => B.value.showTable = !1)
          }, {
            th: I(({ th: t }) => [
              Oe(b(t.name ?? t), 1)
            ]),
            td: I(({ td: t }) => [
              t.value === null ? (a(), o("span", $l, "-")) : (a(), o("b", Nl, b(isNaN(t.value) ? "" : e.value.style.chart.layout.dataLabels.prefix) + b(!isNaN(t.value) && t.value !== null ? Number(t.value.toFixed(e.value.table.td.roundingValue)).toLocaleString() : t) + b(isNaN(t.value) ? "" : e.value.style.chart.layout.dataLabels.suffix), 1)),
              d("span", null, b(t.percentage && !isNaN(t.percentage) ? `(${Number(t.percentage.toFixed(e.value.table.td.roundingPercentage)).toLocaleString()}%)` : ""), 1)
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : v("", !0)
    ], 14, Nt));
  }
}, Gl = /* @__PURE__ */ $t(Il, [["__scopeId", "data-v-390e9759"]]);
export {
  Gl as default
};
